import * as express from "express";
import * as Rx from "rxjs";

import TodoRepository from "../data/todo-repository";
import ITodo from "../../../shared/todo-dto";

export default class TodoController {

  static getAll(req: express.Request, res: express.Response):void {
    TodoRepository.getAll().subscribe(
      todos => res.status(200).json(todos),
      error => res.status(400).json(error)
    );
  }

  static createTodo(req: express.Request, res: express.Response):void {
    let todo: ITodo = req.body;
    TodoRepository.create(todo).subscribe(
      savedTodo => res.status(201).json(savedTodo),
      error => res.status(400).json(error)
    );
  }

  static deleteTodo(req: express.Request, res: express.Response):void {
    let id = req.params.id;

    TodoRepository.deleteById(id).subscribe(
      () => res.status(200).end(),
      error => res.status(400).json(error)
    );
  }
}